/**
 * Ristinolla / Haliva Satu
 *
 * Arpoo siirtoja edellisen siirron lhelle, jolloin tuloo tukalat oltavat!
 *
 * @author Samuli Kaipiainen
 * @version 1.0
 */

public class Satuhali extends Satu
{
	// kuinka lhelle edellist siirtoa yritetn
	protected int etisyys;

	/**
	 * Aloittaa uuden pelin
	 */
	public void uusiPeli()
	{
		super.uusiPeli();

		// nollataan etisyys
		this.etisyys = 1;
	}

	/**
	 * Arpoo Ruudukolle uuden halisiirron
	 *
	 * @param x edellisen siirron x-ruutu
	 * @param y edellisen siirron y-ruutu
	 * @return uusi siirto int[2] {x, y} -taulukkona
	 */
	public int[] siirto(int x, int y)
	{
		// kasvatetaan etisyytt, kun virheelliset siirrot alkaa kasaantua
		if (x == xedellinen && y == yedellinen) etisyys++;
		else etisyys = 1;

		xedellinen = x;
		yedellinen = y;

		// etisyys edellinen-etisyys ... edellinen+etisyys-1
		int halix = x + (int) ((2 * etisyys + 1) * Math.random()) - etisyys;
		int haliy = y + (int) ((2 * etisyys + 1) * Math.random()) - etisyys;

		return new int[] {halix, haliy};
	}
}
